<?php
namespace Indeterminado\Repositories;

class Impobrigtpoper extends \Doctrine\ORM\EntityRepository
{
    public function getImpostosTpOperacao($entrada_saida, $tpOperacao, $nrorg){
        $sql = <<<SQL
        SELECT I.CDIMPOSTO, IM.IDPRODNOTA, IM.SGIMPOSTO
        FROM IMPOBRIGTPOPER I, IMPOSTO IM
        WHERE I.IDENTRSAIDOP = :P_IDENTRSAIDOP
         AND I.CDTIPOOPER = :P_CDTIPOOPER
         AND I.NRORG = :P_NRORG
         AND IM.CDIMPOSTO = I.CDIMPOSTO
SQL;

        $params = array(
            "P_IDENTRSAIDOP" => $entrada_saida,
            "P_CDTIPOOPER" => $tpOperacao,
            "P_NRORG" => $nrorg
        );

        try {
            return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /**
     * Verifica os impostos obrigatorios dos itens da NF. Se este metodo retornar False, e sinal de que existem impostos
     * para determinado tipo de operacao que nao foram calculados.
     *
     * @param $cdfilial
     * @param $nrlanctonf
     * @param $cdimposto
     * @return bool
     */
    public function existeImpostoPorProduto($cdfilial, $nrlanctonf, $cdimposto)
    {
        $sql = "SELECT MAX(A.CDFILIAL) AS CDFILIAL
                 FROM ITEMPRODUTO A
                 WHERE A.CDFILIAL   = '$cdfilial'
                   AND A.NRLANCTONF = '$nrlanctonf'
                   AND NOT EXISTS (
                     SELECT 1
                       FROM ITEMPROIMPOS I
                       WHERE I.CDFILIAL    = A.CDFILIAL
                         AND I.NRLANCTONF  = A.NRLANCTONF
                         AND I.NRSEQITPROD = A.NRSEQITPROD
                         AND I.CDIMPOSTO   = '$cdimposto'
                   )";
        $entityManager = $this->getEntityManager();
        $result = $entityManager->getConnection()->fetchColumn($sql);
        return (bool) $result;
    }

    public function getImpostosObrigatorios($entrada_saida, $tpOperacao, $nrorg, $cdfilial){
        $sql = <<<SQL
        SELECT OB.CDIMPOSTO
          FROM IMPOBRIGTPOPER OB, PARAMFILIAL PF
         WHERE CDTIPOOPER     = :P_CDTIPOOPER    AND
               IDENTRSAIDOP   = :P_IDENTRSAIDOP  AND
               CDFILIAL       = :P_CDFILIAL      AND
               OB.NRORG          = :P_NRORG         AND
               OB.NRORG       = PF.NRORG         AND
               PF.IDUTCTRLFIS = 'S'
SQL;

        $params = array(
            "P_IDENTRSAIDOP" => $entrada_saida,
            "P_CDTIPOOPER" => $tpOperacao,
            "P_CDFILIAL" => $cdfilial,
            "P_NRORG" => $nrorg
        );

        try {
            return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}