/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_INDI                                                     */
/* Tabela : INDICE                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_INDI
BEFORE INSERT OR UPDATE OR DELETE
ON INDICE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUINDI := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDINDICE,0)   <> NVL(:NEW.CDINDICE,0))   OR
         (NVL(:OLD.SGINDICE,0)   <> NVL(:NEW.SGINDICE,0))   OR
         (NVL(:OLD.NMINDICE,0)   <> NVL(:NEW.NMINDICE,0))   OR
         (NVL(:OLD.CDTPINDICE,0) <> NVL(:NEW.CDTPINDICE,0)) OR
         (NVL(:OLD.IDPERVALOR,0) <> NVL(:NEW.IDPERVALOR,0)) THEN
         :NEW.DTULTATUINDI := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('INDICE', '', 'CDTPINDICE='||:OLD.CDTPINDICE||';IDPERVALOR='||:OLD.IDPERVALOR||';CDINDICE='||:OLD.CDINDICE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE INDICE MODIFY DTULTATUINDI DEFAULT SYSDATE
/
