package com.javaseleniumtemplate.tests.naocontrolaalmoxarifado;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.naocontrolaalmoxarifado.RequisicaoDeEstoqueNaoControlaAlmoxarifadoFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.naocontrolaalmoxarifado.RequisicaoDeEstoqueNaoControlaAlmoxarifadoPage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;


public class RequisicaoDeEstoqueNaoControlaAlmoxarifadoTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    RequisicaoDeEstoqueNaoControlaAlmoxarifadoFlows requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows;
    RequisicaoDeEstoqueNaoControlaAlmoxarifadoPage requisicaoDeEstoqueNaoControlaAlmoxarifadoPage;


    @Test(description = "Est-43")
    @Ignore
    public void EfetuarRequisicaoDeEstoque() {
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows = new RequisicaoDeEstoqueNaoControlaAlmoxarifadoFlows();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoPage = new RequisicaoDeEstoqueNaoControlaAlmoxarifadoPage();

        //Parameteres_lancamento
        String descUnidade = "HELA Nao Controla Almoxarifado";
        String campoDescricao = "Teste Automatizado";
        String campoSetor = "Administrativo";
        String campoAlmoxarifadoOrigem = "HELA MATRIZ";
        String campoAlmoxarifadoDestino = "HELA LOJA";
        String campoProduto = "SUMO DE LIMAO - CX12 500ML";
        String campoQuantidadeRequisitada = "1";

        //Rotinas
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoRequisicaoDeEstoque();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade);
        requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows.EfetuarRequisicaodeNaoControlaAlmoxarifadoEstoque(campoDescricao, campoSetor, campoAlmoxarifadoOrigem, campoAlmoxarifadoDestino, campoProduto, campoQuantidadeRequisitada);

        //Banco
        String numerolancado = requisicaoDeEstoqueNaoControlaAlmoxarifadoPage.retornaQuantidadeRequisitadaItem();
        //Assert.assertTrue(DBSteps.retornaQuantidadeRequisitadaEstoque(numerolancado).contains(campoQuantidadeRequisitada));


    }

    @Test(description = "Est-44")
    @Ignore
    public void EditarRequisicaoEstoque() {
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows = new RequisicaoDeEstoqueNaoControlaAlmoxarifadoFlows();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoPage = new RequisicaoDeEstoqueNaoControlaAlmoxarifadoPage();

        //Parameteres_lancamento
        String descUnidade = "HELA Nao Controla Almoxarifado";
        String campoEditado = "Deletar";

        //Rotinas
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoRequisicaoDeEstoque();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade);
        requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows.EditarRequsicaoEstoque(campoEditado);

    }

    @Test(description = "Est-45")
    @Ignore
    public void ExcluirRequisicaoEstoque() {

        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows = new RequisicaoDeEstoqueNaoControlaAlmoxarifadoFlows();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoPage = new RequisicaoDeEstoqueNaoControlaAlmoxarifadoPage();

        //Parameters
        String descUnidade = "HELA Nao Controla Almoxarifado";
        //Rotine
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoRequisicaoDeEstoque();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade);
        requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows.ExcluirRequisicaoDeEstoque();


    }



    @Test(description = "Est-00")
    @Ignore
    public void TesteBanco(){

        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoFlows = new RequisicaoDeEstoqueNaoControlaAlmoxarifadoFlows();
        requisicaoDeEstoqueNaoControlaAlmoxarifadoPage =  new RequisicaoDeEstoqueNaoControlaAlmoxarifadoPage();


        //Rotinas:
        // loginFlows.efetuarLogin();
        String ntlancestq = "0000000005";
        String teste =  DBSteps.retornaQuantidadeRequisitadaEstoque(ntlancestq);
        System.out.println(teste);


    }

}

